/*------------------------------------------------------------------*/
/* Bayer p^[ ACPI ŃJ[摜𐶐                       */
/*                                                                  */
/*  2018/09/09  T.Kimura    Initial                                 */
/*  2020/11/27  T.Kimura    Bayer p^[̒[̏֐ւ̏C    */
/*                                                                  */
/*------------------------------------------------------------------*/
/* Copyright by T.Kimura 2018-2020                                  */
/*------------------------------------------------------------------*/

#include "stdio.h"
#include "stdlib.h"
#include "image.h"

#define     MONO_Depth      8       /* Mono color depth */
#define     COLOR_Depth     24      /* Full Color depth */

/*----------------------*/
/* Main Routine         */
/*----------------------*/
int main( int argv, char *argc[] )
{
    ImageData *in_img, *out_img;        /* Ǎ摜Co摜 */
    int     x, y;                       /* 摜S̗p̃JE^ */
    int     lx, ly;                     /* Ǐ̈p̃JE^ */
    int     res;                        /* ֐ return p */
    int     p;                          /* pixel data   */
    Pixel   pix;                        /* Pixel \ (r, g, b) */

    int     g_flag;                     /* Green vZptOC1̎vZ */
    int     alpha, beta;                /* Green vZp */
    int     lp_G[5][5];                 /* Green p̋Ǐ̈f[^ۑpz */
    int     lp_RB[3][3];                /* Red, Blue p̋Ǐ̈f[^ۑpz */

    int     test=0;

    printf("ACPI vO ver 1.1 (2020/11/27)\n");

    if( argv<3 ) {
        printf("p[^܂\n");
        printf("gen_bayer [read image file name] [write image file name]\n");
        return 1;
    }

   // t@C摜f[^̓ǂݍ
    res=readBMPfile( argc[1]/*read image*/, &in_img);
    if( res<0 ) {
        printf("摜f[^ǂ߂܂");
        return 1;
    }

    /* t@CmN(Bayer p^[j摜ǂmF */
    if( in_img->depth != MONO_Depth ) {
        printf("mNiBayer p^[j摜ł͂܂\n");
        return 1;
    }

    // i[p摜f[^쐬 (Full Color:24bit)
    out_img = createImage( in_img->width, in_img->height, COLOR_Depth );

    /*---------------------------------------------------------------------------------------*/
    /* 摜f[^͓ǂݍ񂾎 in_img ɓCHEopƂăf[^ out_img ɓ */
    /*---------------------------------------------------------------------------------------*/

    /*--------------------------------------------------------*/
    /* ŏ Green Ȃfɂ Green 𐶐 */
    /*--------------------------------------------------------*/
    for( y=0 ; y<in_img->height ; y++ ) {
        for( x=0 ; x<in_img->width ; x++ ) {

            /* Y ̎ */
            if( (y%2)==0 ) {
                /* X ̎ */
                if ( (x%2)==0 ) {
                    g_flag = 1;     /* Green 𐄒肷 */
                }
                /* X ̎ */
                else {
                    g_flag = 0;     /* Green ͂̂܂ܓKp */
                }
            }
            /* Y ̎ */
            else {
                /* X ̎ */
                if( (x%2)==1 ){
                    g_flag = 1;     /* Green 𐄒肷 */
                }
                /* X ̎ */
                else {
                    g_flag = 0;     /* Green ͂̂܂ܓKp */
                }
            }

            if( g_flag == 1 ) {
                /* Green pǏ̈f[^ۑpf[^̃Rs[ */
                for( ly=0 ; ly<5 ; ly++ ) {
                    for( lx=0 ; lx<5 ; lx++ ) {
                        getPixel_Bayer(in_img, x+lx-2, y+ly-2, &pix);   /* 2020/11/27 */
                        lp_G[ly][lx] = pix.r;
                    }
                }
                /* Green ̎̔ʗp̓o */
                alpha = abs( -lp_G[0][2]/*R13*/ + 2*lp_G[2][2]/*R33*/ - lp_G[4][2]/*R53*/ )
                      + abs( lp_G[1][2]/*G23*/ - lp_G[3][2]/*G43*/ );

                beta  = abs( -lp_G[2][0]/*R31*/ + 2*lp_G[2][2]/*R33*/ - lp_G[2][4]/*R35*/ )
                      + abs( lp_G[2][1]/*G32*/ - lp_G[2][3]/*G34*/ );

                if( alpha < beta ) {
                    pix.g = (int)( ((lp_G[1][2]/*G23*/+lp_G[3][2]/*G43*/)/2.0)
                                  +((-lp_G[0][2]/*R13*/+2*lp_G[2][2]/*R33*/-lp_G[4][2]/*R53*/)/4.0) );
                }
                else if( alpha > beta ) {
                    pix.g = (int)( ((lp_G[2][1]/*G32*/+lp_G[2][3]/*G34*/)/2.0)
                                  +((-lp_G[2][0]/*R31*/+2*lp_G[2][2]/*R33*/-lp_G[2][4]/*R35*/)/4.0) );
                }
                /* appha = beta */
                else {
                    pix.g = (int)( ((lp_G[1][2]+lp_G[3][2]+lp_G[2][1]+lp_G[2][3])/4.0)
                                  +((-lp_G[0][2]-lp_G[2][0]+4*lp_G[2][2]-lp_G[2][4]-lp_G[4][2])/8.0) );
                }
            }
            /* Green ̂܂܃Rs[ĕۑ */
            else {
                getPixel_Bayer(in_img, x, y, &pix);     /* 2020/11/27 */
            }

#if 1   /* Dummy Data */
            pix.r = 0;
            pix.b = 0;
#endif

            setPixel(out_img, x, y, &pix);
        } /* x@Green */
    } /* y@Green */

#if 1
    /*------------------------------*/
    /* RED  BULE ɑ΂鏈 */
    /*------------------------------*/
    for( y=0 ; y<in_img->height ; y++ ){
        for( x=0 ; x<in_img->width ; x++ ) {

            /* Red/Bule pǏ̈f[^ۑpf[^̃Rs[ */
            for( ly=0 ; ly<3 ; ly++ ) {
                for( lx=0 ; lx<3 ; lx++ ) {
                    /* Red/Bule ͌Mg */
                    getPixel_Bayer(in_img, x+lx-1, y+ly-1, &pix);   /* 2020/11/27 */
                    lp_RB[ly][lx] = pix.r;
                    /* Green ͏LŐ肵l܂͌Mg */
                    getPixel_Bayer(out_img, x+lx-1, y+ly-1, &pix);  /* 2020/11/27 */
                    lp_G[ly][lx] = pix.g;
                }
            }

            /* -------------------------------------------------*/
            /* MԂ܂͐ɑ΂鏈iƂȂj */
            /* -------------------------------------------------*/
            if( ((y%2)==0 && (x%2)==0) || ((y%2)==1 && (x%2)==1) ) {
                /* Red/Bule ̎̔ʗp̓o */
                alpha = abs( -lp_G[0][2]/*G^24*/ + 2*lp_G[1][1]/*G^33*/ - lp_G[2][0]/*G^42*/ )
                      + abs( lp_RB[0][2]/*RB24*/ - lp_RB[2][0]/*RB42*/ );

                beta  = abs( -lp_G[0][0]/*G^22*/ + 2*lp_G[1][1]/*G^33*/ - lp_G[2][2]/*G^44*/ )
                      + abs( lp_RB[0][0]/*RB22*/ - lp_RB[2][2]/*RB44*/ );

                if( alpha < beta ) {
                    p = (int)( ((lp_RB[0][2]+lp_RB[2][0])/2.0)
                             + ((-lp_G[0][2]+2*lp_G[1][1]-lp_G[2][0])/4.0) );
                }
                else if( alpha > beta ) {
                    p = (int)( ((lp_RB[0][0]+lp_RB[2][2])/2.0)
                             + ((-lp_G[0][0]+2*lp_G[1][1]-lp_G[2][2])/4.0) );
                }
                /* alpht = beta */
                else {
                    p = (int)( ((lp_RB[0][2]+lp_RB[2][0]+lp_RB[0][0]+lp_RB[2][2])/4.0)
                             + ((-lp_G[0][0]-lp_G[0][2]+4*lp_G[1][1]-lp_G[2][0]-lp_G[2][2])/8.0) );
                }

                /* MFԂɑ΂鏈i̐j */
                if( (y%2)==0 ) {
//              if( (y%2)==0 && (x%2)==0 ) {
                    pix.r = lp_RB[1][1];    /* Ԃ͌M */
                    pix.g = lp_G[1][1];     /*  */
                    pix.b = p;
                }
                /* MFɑ΂鏈iԂ̐j*/
                if( (y%2)==1 ) {
//              if( (y%2)==1 && (x%2)==1 ) {
                    pix.r = p;
                    pix.g = lp_G[1][1];     /*  */
                    pix.b = lp_RB[1][1];    /* ͌M */
                }
            }

            /* -----------------------*/
            /* M΂ɑ΂鏈 */
            /* -----------------------*/
            else {
//          else if( ((y%2)==0 && (x%2)==1) || ((y%2)==1 && (x%2)==0 ) ) {
                /* c̐F̐ */
                p = (int)( ((lp_RB[0][1]+lp_RB[2][1])/2.0)
                         + ((-lp_G[0][1]+2*lp_G[1][1]-lp_G[2][1])/4.0) );
                if( (y%2)==1 ) {
                    pix.r = p;      /* s͏c */
                }
                else {
                    pix.b = p;      /* s͏c */
                }

                /* ̐F̐ */
                p = (int)( ((lp_RB[1][0]+lp_RB[1][2])/2.0)
                         + ((-lp_G[1][0]+2*lp_G[1][1]-lp_G[1][2])/4.0) );
                if( (y%2)==0 ) {
                    pix.r = p;      /* s͉ */
                }
                else {
                    pix.b = p;      /* s͉ */
                }

                pix.g = lp_G[1][1];
            }

            /* Pixel\̃f[^op֕ۑ */
            setPixel(out_img, x, y, &pix);

        } /* X@Red/Blue */

    } /* Y@Red/Bule */
#endif

    // t@C։摜f[^o
    writeBMPfile( argc[2]/*write image*/, out_img);
    disposeImage(in_img);
    disposeImage(out_img);

    return 0;
}
